﻿#include"../localedef.h"

namespace fast_io_i18n
{
namespace
{

inline constexpr std::size_t monetary_mon_grouping_storage[]{3,2};

inline constexpr std::size_t numeric_grouping_storage[]{3};

inline constexpr lc_all lc_all_global{.identification={.name=tsc("hne_IN"),.encoding=tsc(FAST_IO_LOCALE_ENCODING),.title=tsc("Chhattisgarhi language locale for India"),.source=tsc("Red Hat, Pune\t\t;\t\tfast_io"),.address=tsc("Marisfot III, Marigold Premises, East-Wing, Kalyaninagar, Pune, India-411014\t\t;\t\thttps://gitee.com/qabeowjbtkwb/fast_io\t\t;\t\thttps://github.com/cppfastio/fast_io"),.contact=tsc("fast_io"),.email=tsc("bug-glibc-locales@gnu.org;euloanty@live.com"),.tel=tsc(""),.fax=tsc(""),.language=tsc("Chhattisgarhi"),.territory=tsc("India"),.revision=tsc("1.0"),.date=tsc("2008-12-03")},.monetary={.int_curr_symbol=tsc("INR "),.currency_symbol=tsc("₹"),.mon_decimal_point=tsc("."),.mon_thousands_sep=tsc(","),.mon_grouping={monetary_mon_grouping_storage,2},.positive_sign=tsc(""),.negative_sign=tsc("-"),.int_frac_digits=2,.frac_digits=2,.p_cs_precedes=1,.p_sep_by_space=0,.n_cs_precedes=1,.n_sep_by_space=0,.p_sign_posn=1,.n_sign_posn=1},.numeric={.decimal_point=tsc("."),.thousands_sep=tsc(","),.grouping={numeric_grouping_storage,1}},.time={.abday={tsc("इत"),tsc("सोम"),tsc("मंग"),tsc("बुध"),tsc("बिर"),tsc("सुक"),tsc("सनि")},.day={tsc("इतवार"),tsc("सोमवार"),tsc("मंगलवार"),tsc("बुधवार"),tsc("बिरसपत"),tsc("सुकरवार"),tsc("सनिवार")},.abmon={tsc("जन"),tsc("फर"),tsc("मार्च"),tsc("अप"),tsc("मई"),tsc("जून"),tsc("जुला"),tsc("अग"),tsc("सित"),tsc("अकटू"),tsc("नव"),tsc("दिस")},.mon={tsc("जनवरी"),tsc("फरवरी"),tsc("मार्च"),tsc("अपरेल"),tsc("मई"),tsc("जून"),tsc("जुलाई"),tsc("अगस्त"),tsc("सितमबर"),tsc("अकटूबर"),tsc("नवमबर"),tsc("दिसमबर")},.d_t_fmt=tsc("%A %d %b %Y %I:%M:%S %p"),.d_fmt=tsc("%-d//%-m//%y"),.t_fmt=tsc("%I:%M:%S %p %Z"),.t_fmt_ampm=tsc("%I:%M:%S %p %Z"),.date_fmt=tsc("%A %d %b %Y %I:%M:%S %p %Z"),.am_pm={tsc("बिहिनियाँ"),tsc("मंझनियाँ")},.week={7,19971130,1}},.messages={.yesexpr=tsc("^[+1yYह]"),.noexpr=tsc("^[-0nNन]"),.yesstr=tsc("हव"),.nostr=tsc("नइ")},.paper={.width=210,.height=297},.telephone={.tel_int_fmt=tsc("+%c ;%a ;%l"),.int_select=tsc("00"),.int_prefix=tsc("91")},.name={.name_fmt=tsc("%p%t%f%t%g"),.name_gen=tsc(""),.name_miss=tsc("कुंवारी"),.name_mr=tsc("सिरीमान"),.name_mrs=tsc("सिरीमती"),.name_ms=tsc("कुं")},.address={.postal_fmt=tsc("%z%c%T%s%b%e%r"),.country_name=tsc("भारत"),.country_ab2=tsc("IN"),.country_ab3=tsc("IND"),.country_num=356,.country_car=tsc("IND"),.lang_name=tsc("छत्तीसगढ़ी"),.lang_term=tsc("hne")},.measurement={.measurement=1}};

inline constexpr wlc_all wlc_all_global{.identification={.name=tsc(L"hne_IN"),.encoding=tsc(FAST_IO_LOCALE_LENCODING),.title=tsc(L"Chhattisgarhi language locale for India"),.source=tsc(L"Red Hat, Pune\t\t;\t\tfast_io"),.address=tsc(L"Marisfot III, Marigold Premises, East-Wing, Kalyaninagar, Pune, India-411014\t\t;\t\thttps://gitee.com/qabeowjbtkwb/fast_io\t\t;\t\thttps://github.com/cppfastio/fast_io"),.contact=tsc(L"fast_io"),.email=tsc(L"bug-glibc-locales@gnu.org;euloanty@live.com"),.tel=tsc(L""),.fax=tsc(L""),.language=tsc(L"Chhattisgarhi"),.territory=tsc(L"India"),.revision=tsc(L"1.0"),.date=tsc(L"2008-12-03")},.monetary={.int_curr_symbol=tsc(L"INR "),.currency_symbol=tsc(L"₹"),.mon_decimal_point=tsc(L"."),.mon_thousands_sep=tsc(L","),.mon_grouping={monetary_mon_grouping_storage,2},.positive_sign=tsc(L""),.negative_sign=tsc(L"-"),.int_frac_digits=2,.frac_digits=2,.p_cs_precedes=1,.p_sep_by_space=0,.n_cs_precedes=1,.n_sep_by_space=0,.p_sign_posn=1,.n_sign_posn=1},.numeric={.decimal_point=tsc(L"."),.thousands_sep=tsc(L","),.grouping={numeric_grouping_storage,1}},.time={.abday={tsc(L"इत"),tsc(L"सोम"),tsc(L"मंग"),tsc(L"बुध"),tsc(L"बिर"),tsc(L"सुक"),tsc(L"सनि")},.day={tsc(L"इतवार"),tsc(L"सोमवार"),tsc(L"मंगलवार"),tsc(L"बुधवार"),tsc(L"बिरसपत"),tsc(L"सुकरवार"),tsc(L"सनिवार")},.abmon={tsc(L"जन"),tsc(L"फर"),tsc(L"मार्च"),tsc(L"अप"),tsc(L"मई"),tsc(L"जून"),tsc(L"जुला"),tsc(L"अग"),tsc(L"सित"),tsc(L"अकटू"),tsc(L"नव"),tsc(L"दिस")},.mon={tsc(L"जनवरी"),tsc(L"फरवरी"),tsc(L"मार्च"),tsc(L"अपरेल"),tsc(L"मई"),tsc(L"जून"),tsc(L"जुलाई"),tsc(L"अगस्त"),tsc(L"सितमबर"),tsc(L"अकटूबर"),tsc(L"नवमबर"),tsc(L"दिसमबर")},.d_t_fmt=tsc(L"%A %d %b %Y %I:%M:%S %p"),.d_fmt=tsc(L"%-d//%-m//%y"),.t_fmt=tsc(L"%I:%M:%S %p %Z"),.t_fmt_ampm=tsc(L"%I:%M:%S %p %Z"),.date_fmt=tsc(L"%A %d %b %Y %I:%M:%S %p %Z"),.am_pm={tsc(L"बिहिनियाँ"),tsc(L"मंझनियाँ")},.week={7,19971130,1}},.messages={.yesexpr=tsc(L"^[+1yYह]"),.noexpr=tsc(L"^[-0nNन]"),.yesstr=tsc(L"हव"),.nostr=tsc(L"नइ")},.paper={.width=210,.height=297},.telephone={.tel_int_fmt=tsc(L"+%c ;%a ;%l"),.int_select=tsc(L"00"),.int_prefix=tsc(L"91")},.name={.name_fmt=tsc(L"%p%t%f%t%g"),.name_gen=tsc(L""),.name_miss=tsc(L"कुंवारी"),.name_mr=tsc(L"सिरीमान"),.name_mrs=tsc(L"सिरीमती"),.name_ms=tsc(L"कुं")},.address={.postal_fmt=tsc(L"%z%c%T%s%b%e%r"),.country_name=tsc(L"भारत"),.country_ab2=tsc(L"IN"),.country_ab3=tsc(L"IND"),.country_num=356,.country_car=tsc(L"IND"),.lang_name=tsc(L"छत्तीसगढ़ी"),.lang_term=tsc(L"hne")},.measurement={.measurement=1}};

inline constexpr u8lc_all u8lc_all_global{.identification={.name=tsc(u8"hne_IN"),.encoding=tsc(FAST_IO_LOCALE_u8ENCODING),.title=tsc(u8"Chhattisgarhi language locale for India"),.source=tsc(u8"Red Hat, Pune\t\t;\t\tfast_io"),.address=tsc(u8"Marisfot III, Marigold Premises, East-Wing, Kalyaninagar, Pune, India-411014\t\t;\t\thttps://gitee.com/qabeowjbtkwb/fast_io\t\t;\t\thttps://github.com/cppfastio/fast_io"),.contact=tsc(u8"fast_io"),.email=tsc(u8"bug-glibc-locales@gnu.org;euloanty@live.com"),.tel=tsc(u8""),.fax=tsc(u8""),.language=tsc(u8"Chhattisgarhi"),.territory=tsc(u8"India"),.revision=tsc(u8"1.0"),.date=tsc(u8"2008-12-03")},.monetary={.int_curr_symbol=tsc(u8"INR "),.currency_symbol=tsc(u8"₹"),.mon_decimal_point=tsc(u8"."),.mon_thousands_sep=tsc(u8","),.mon_grouping={monetary_mon_grouping_storage,2},.positive_sign=tsc(u8""),.negative_sign=tsc(u8"-"),.int_frac_digits=2,.frac_digits=2,.p_cs_precedes=1,.p_sep_by_space=0,.n_cs_precedes=1,.n_sep_by_space=0,.p_sign_posn=1,.n_sign_posn=1},.numeric={.decimal_point=tsc(u8"."),.thousands_sep=tsc(u8","),.grouping={numeric_grouping_storage,1}},.time={.abday={tsc(u8"इत"),tsc(u8"सोम"),tsc(u8"मंग"),tsc(u8"बुध"),tsc(u8"बिर"),tsc(u8"सुक"),tsc(u8"सनि")},.day={tsc(u8"इतवार"),tsc(u8"सोमवार"),tsc(u8"मंगलवार"),tsc(u8"बुधवार"),tsc(u8"बिरसपत"),tsc(u8"सुकरवार"),tsc(u8"सनिवार")},.abmon={tsc(u8"जन"),tsc(u8"फर"),tsc(u8"मार्च"),tsc(u8"अप"),tsc(u8"मई"),tsc(u8"जून"),tsc(u8"जुला"),tsc(u8"अग"),tsc(u8"सित"),tsc(u8"अकटू"),tsc(u8"नव"),tsc(u8"दिस")},.mon={tsc(u8"जनवरी"),tsc(u8"फरवरी"),tsc(u8"मार्च"),tsc(u8"अपरेल"),tsc(u8"मई"),tsc(u8"जून"),tsc(u8"जुलाई"),tsc(u8"अगस्त"),tsc(u8"सितमबर"),tsc(u8"अकटूबर"),tsc(u8"नवमबर"),tsc(u8"दिसमबर")},.d_t_fmt=tsc(u8"%A %d %b %Y %I:%M:%S %p"),.d_fmt=tsc(u8"%-d//%-m//%y"),.t_fmt=tsc(u8"%I:%M:%S %p %Z"),.t_fmt_ampm=tsc(u8"%I:%M:%S %p %Z"),.date_fmt=tsc(u8"%A %d %b %Y %I:%M:%S %p %Z"),.am_pm={tsc(u8"बिहिनियाँ"),tsc(u8"मंझनियाँ")},.week={7,19971130,1}},.messages={.yesexpr=tsc(u8"^[+1yYह]"),.noexpr=tsc(u8"^[-0nNन]"),.yesstr=tsc(u8"हव"),.nostr=tsc(u8"नइ")},.paper={.width=210,.height=297},.telephone={.tel_int_fmt=tsc(u8"+%c ;%a ;%l"),.int_select=tsc(u8"00"),.int_prefix=tsc(u8"91")},.name={.name_fmt=tsc(u8"%p%t%f%t%g"),.name_gen=tsc(u8""),.name_miss=tsc(u8"कुंवारी"),.name_mr=tsc(u8"सिरीमान"),.name_mrs=tsc(u8"सिरीमती"),.name_ms=tsc(u8"कुं")},.address={.postal_fmt=tsc(u8"%z%c%T%s%b%e%r"),.country_name=tsc(u8"भारत"),.country_ab2=tsc(u8"IN"),.country_ab3=tsc(u8"IND"),.country_num=356,.country_car=tsc(u8"IND"),.lang_name=tsc(u8"छत्तीसगढ़ी"),.lang_term=tsc(u8"hne")},.measurement={.measurement=1}};

inline constexpr u16lc_all u16lc_all_global{.identification={.name=tsc(u"hne_IN"),.encoding=tsc(FAST_IO_LOCALE_uENCODING),.title=tsc(u"Chhattisgarhi language locale for India"),.source=tsc(u"Red Hat, Pune\t\t;\t\tfast_io"),.address=tsc(u"Marisfot III, Marigold Premises, East-Wing, Kalyaninagar, Pune, India-411014\t\t;\t\thttps://gitee.com/qabeowjbtkwb/fast_io\t\t;\t\thttps://github.com/cppfastio/fast_io"),.contact=tsc(u"fast_io"),.email=tsc(u"bug-glibc-locales@gnu.org;euloanty@live.com"),.tel=tsc(u""),.fax=tsc(u""),.language=tsc(u"Chhattisgarhi"),.territory=tsc(u"India"),.revision=tsc(u"1.0"),.date=tsc(u"2008-12-03")},.monetary={.int_curr_symbol=tsc(u"INR "),.currency_symbol=tsc(u"₹"),.mon_decimal_point=tsc(u"."),.mon_thousands_sep=tsc(u","),.mon_grouping={monetary_mon_grouping_storage,2},.positive_sign=tsc(u""),.negative_sign=tsc(u"-"),.int_frac_digits=2,.frac_digits=2,.p_cs_precedes=1,.p_sep_by_space=0,.n_cs_precedes=1,.n_sep_by_space=0,.p_sign_posn=1,.n_sign_posn=1},.numeric={.decimal_point=tsc(u"."),.thousands_sep=tsc(u","),.grouping={numeric_grouping_storage,1}},.time={.abday={tsc(u"इत"),tsc(u"सोम"),tsc(u"मंग"),tsc(u"बुध"),tsc(u"बिर"),tsc(u"सुक"),tsc(u"सनि")},.day={tsc(u"इतवार"),tsc(u"सोमवार"),tsc(u"मंगलवार"),tsc(u"बुधवार"),tsc(u"बिरसपत"),tsc(u"सुकरवार"),tsc(u"सनिवार")},.abmon={tsc(u"जन"),tsc(u"फर"),tsc(u"मार्च"),tsc(u"अप"),tsc(u"मई"),tsc(u"जून"),tsc(u"जुला"),tsc(u"अग"),tsc(u"सित"),tsc(u"अकटू"),tsc(u"नव"),tsc(u"दिस")},.mon={tsc(u"जनवरी"),tsc(u"फरवरी"),tsc(u"मार्च"),tsc(u"अपरेल"),tsc(u"मई"),tsc(u"जून"),tsc(u"जुलाई"),tsc(u"अगस्त"),tsc(u"सितमबर"),tsc(u"अकटूबर"),tsc(u"नवमबर"),tsc(u"दिसमबर")},.d_t_fmt=tsc(u"%A %d %b %Y %I:%M:%S %p"),.d_fmt=tsc(u"%-d//%-m//%y"),.t_fmt=tsc(u"%I:%M:%S %p %Z"),.t_fmt_ampm=tsc(u"%I:%M:%S %p %Z"),.date_fmt=tsc(u"%A %d %b %Y %I:%M:%S %p %Z"),.am_pm={tsc(u"बिहिनियाँ"),tsc(u"मंझनियाँ")},.week={7,19971130,1}},.messages={.yesexpr=tsc(u"^[+1yYह]"),.noexpr=tsc(u"^[-0nNन]"),.yesstr=tsc(u"हव"),.nostr=tsc(u"नइ")},.paper={.width=210,.height=297},.telephone={.tel_int_fmt=tsc(u"+%c ;%a ;%l"),.int_select=tsc(u"00"),.int_prefix=tsc(u"91")},.name={.name_fmt=tsc(u"%p%t%f%t%g"),.name_gen=tsc(u""),.name_miss=tsc(u"कुंवारी"),.name_mr=tsc(u"सिरीमान"),.name_mrs=tsc(u"सिरीमती"),.name_ms=tsc(u"कुं")},.address={.postal_fmt=tsc(u"%z%c%T%s%b%e%r"),.country_name=tsc(u"भारत"),.country_ab2=tsc(u"IN"),.country_ab3=tsc(u"IND"),.country_num=356,.country_car=tsc(u"IND"),.lang_name=tsc(u"छत्तीसगढ़ी"),.lang_term=tsc(u"hne")},.measurement={.measurement=1}};

inline constexpr u32lc_all u32lc_all_global{.identification={.name=tsc(U"hne_IN"),.encoding=tsc(FAST_IO_LOCALE_UENCODING),.title=tsc(U"Chhattisgarhi language locale for India"),.source=tsc(U"Red Hat, Pune\t\t;\t\tfast_io"),.address=tsc(U"Marisfot III, Marigold Premises, East-Wing, Kalyaninagar, Pune, India-411014\t\t;\t\thttps://gitee.com/qabeowjbtkwb/fast_io\t\t;\t\thttps://github.com/cppfastio/fast_io"),.contact=tsc(U"fast_io"),.email=tsc(U"bug-glibc-locales@gnu.org;euloanty@live.com"),.tel=tsc(U""),.fax=tsc(U""),.language=tsc(U"Chhattisgarhi"),.territory=tsc(U"India"),.revision=tsc(U"1.0"),.date=tsc(U"2008-12-03")},.monetary={.int_curr_symbol=tsc(U"INR "),.currency_symbol=tsc(U"₹"),.mon_decimal_point=tsc(U"."),.mon_thousands_sep=tsc(U","),.mon_grouping={monetary_mon_grouping_storage,2},.positive_sign=tsc(U""),.negative_sign=tsc(U"-"),.int_frac_digits=2,.frac_digits=2,.p_cs_precedes=1,.p_sep_by_space=0,.n_cs_precedes=1,.n_sep_by_space=0,.p_sign_posn=1,.n_sign_posn=1},.numeric={.decimal_point=tsc(U"."),.thousands_sep=tsc(U","),.grouping={numeric_grouping_storage,1}},.time={.abday={tsc(U"इत"),tsc(U"सोम"),tsc(U"मंग"),tsc(U"बुध"),tsc(U"बिर"),tsc(U"सुक"),tsc(U"सनि")},.day={tsc(U"इतवार"),tsc(U"सोमवार"),tsc(U"मंगलवार"),tsc(U"बुधवार"),tsc(U"बिरसपत"),tsc(U"सुकरवार"),tsc(U"सनिवार")},.abmon={tsc(U"जन"),tsc(U"फर"),tsc(U"मार्च"),tsc(U"अप"),tsc(U"मई"),tsc(U"जून"),tsc(U"जुला"),tsc(U"अग"),tsc(U"सित"),tsc(U"अकटू"),tsc(U"नव"),tsc(U"दिस")},.mon={tsc(U"जनवरी"),tsc(U"फरवरी"),tsc(U"मार्च"),tsc(U"अपरेल"),tsc(U"मई"),tsc(U"जून"),tsc(U"जुलाई"),tsc(U"अगस्त"),tsc(U"सितमबर"),tsc(U"अकटूबर"),tsc(U"नवमबर"),tsc(U"दिसमबर")},.d_t_fmt=tsc(U"%A %d %b %Y %I:%M:%S %p"),.d_fmt=tsc(U"%-d//%-m//%y"),.t_fmt=tsc(U"%I:%M:%S %p %Z"),.t_fmt_ampm=tsc(U"%I:%M:%S %p %Z"),.date_fmt=tsc(U"%A %d %b %Y %I:%M:%S %p %Z"),.am_pm={tsc(U"बिहिनियाँ"),tsc(U"मंझनियाँ")},.week={7,19971130,1}},.messages={.yesexpr=tsc(U"^[+1yYह]"),.noexpr=tsc(U"^[-0nNन]"),.yesstr=tsc(U"हव"),.nostr=tsc(U"नइ")},.paper={.width=210,.height=297},.telephone={.tel_int_fmt=tsc(U"+%c ;%a ;%l"),.int_select=tsc(U"00"),.int_prefix=tsc(U"91")},.name={.name_fmt=tsc(U"%p%t%f%t%g"),.name_gen=tsc(U""),.name_miss=tsc(U"कुंवारी"),.name_mr=tsc(U"सिरीमान"),.name_mrs=tsc(U"सिरीमती"),.name_ms=tsc(U"कुं")},.address={.postal_fmt=tsc(U"%z%c%T%s%b%e%r"),.country_name=tsc(U"भारत"),.country_ab2=tsc(U"IN"),.country_ab3=tsc(U"IND"),.country_num=356,.country_car=tsc(U"IND"),.lang_name=tsc(U"छत्तीसगढ़ी"),.lang_term=tsc(U"hne")},.measurement={.measurement=1}};


}
}

#include"../main.h"