﻿#include"../localedef.h"

namespace fast_io_i18n
{
namespace
{

inline constexpr std::size_t numeric_grouping_storage[]{3};

inline constexpr lc_all lc_all_global{.identification={.name=tsc("km_KH"),.encoding=tsc(FAST_IO_LOCALE_ENCODING),.title=tsc("Khmer locale for Cambodia"),.source=tsc("fast_io"),.address=tsc("https://gitee.com/qabeowjbtkwb/fast_io\t\t;\t\thttps://github.com/cppfastio/fast_io"),.contact=tsc("Jens Herden at: jens@khmeros.info\t\t;\t\tfast_io"),.email=tsc("bug-glibc-locales@gnu.org;euloanty@live.com"),.tel=tsc(""),.fax=tsc(""),.language=tsc("Khmer"),.territory=tsc("Cambodia"),.revision=tsc("1.0"),.date=tsc("2005-3-15")},.monetary={.int_curr_symbol=tsc("KHR "),.currency_symbol=tsc("៛"),.mon_decimal_point=tsc("."),.mon_thousands_sep=tsc(","),.mon_grouping={numeric_grouping_storage,1},.positive_sign=tsc(""),.negative_sign=tsc("-"),.int_frac_digits=2,.frac_digits=2,.p_cs_precedes=0,.p_sep_by_space=0,.n_cs_precedes=0,.n_sep_by_space=0,.int_p_cs_precedes=0,.int_p_sep_by_space=0,.int_n_cs_precedes=0,.int_n_sep_by_space=0,.p_sign_posn=1,.n_sign_posn=1,.int_p_sign_posn=1,.int_n_sign_posn=1},.numeric={.decimal_point=tsc("."),.thousands_sep=tsc(","),.grouping={numeric_grouping_storage,1}},.time={.abday={tsc("អា"),tsc("ច"),tsc("អ"),tsc("ពុ"),tsc("ព្រ"),tsc("សុ"),tsc("ស")},.day={tsc("ថ្ងៃ​អាទិត្យ"),tsc("ថ្ងៃ​ច័ន្ទ"),tsc("ថ្ងៃ​អង្គារ"),tsc("ថ្ងៃ​ពុធ"),tsc("ថ្ងៃ​ព្រហស្បតិ៍"),tsc("ថ្ងៃ​សុក្រ"),tsc("ថ្ងៃ​សៅរ៍")},.abmon={tsc("១"),tsc("២"),tsc("៣"),tsc("៤"),tsc("៥"),tsc("៦"),tsc("៧"),tsc("៨"),tsc("៩"),tsc("១០"),tsc("១១"),tsc("១២")},.mon={tsc("មករា"),tsc("កុម្ភៈ"),tsc("មីនា"),tsc("មេសា"),tsc("ឧសភា"),tsc("មិថុនា"),tsc("កក្កដា"),tsc("សីហា"),tsc("កញ្ញា"),tsc("តុលា"),tsc("វិច្ឆិកា"),tsc("ធ្នូ")},.d_t_fmt=tsc("%A ថ្ងៃ %e ខែ %B ឆ្នាំ %Y, %H ម៉ោង %M នាទី %S វិនាទី​"),.d_fmt=tsc("%e %B %Y"),.t_fmt=tsc("%H:%M:%S"),.date_fmt=tsc("%A ថ្ងៃ %e ខែ %B ឆ្នាំ %Y, %H ម៉ោង %M នាទី %S វិនាទី​"),.am_pm={tsc("ព្រឹក"),tsc("ល្ងាច")},.week={7,19971130,1},.first_weekday=1},.messages={.yesexpr=tsc("^[+1yYប]"),.noexpr=tsc("^[-0nNទ]"),.yesstr=tsc("បាទ/ចាស"),.nostr=tsc("ទេ")},.paper={.width=210,.height=297},.telephone={.tel_int_fmt=tsc("+%c %a %l"),.tel_dom_fmt=tsc("(%A)%l"),.int_select=tsc("001"),.int_prefix=tsc("855")},.name={.name_fmt=tsc("%d%t%g%t%m%t%f")},.address={.postal_fmt=tsc("%f%N%a%N%d%N%r%t%e%t%b%N%h%t%s%N%T%N%S%N%z%c%N"),.country_name=tsc("កម្ពុជា"),.country_ab2=tsc("KH"),.country_ab3=tsc("KHM"),.country_num=116,.country_car=tsc("KH"),.lang_name=tsc("ខ្មែរ"),.lang_ab=tsc("km"),.lang_term=tsc("khm"),.lang_lib=tsc("khm")},.measurement={.measurement=1}};

inline constexpr wlc_all wlc_all_global{.identification={.name=tsc(L"km_KH"),.encoding=tsc(FAST_IO_LOCALE_LENCODING),.title=tsc(L"Khmer locale for Cambodia"),.source=tsc(L"fast_io"),.address=tsc(L"https://gitee.com/qabeowjbtkwb/fast_io\t\t;\t\thttps://github.com/cppfastio/fast_io"),.contact=tsc(L"Jens Herden at: jens@khmeros.info\t\t;\t\tfast_io"),.email=tsc(L"bug-glibc-locales@gnu.org;euloanty@live.com"),.tel=tsc(L""),.fax=tsc(L""),.language=tsc(L"Khmer"),.territory=tsc(L"Cambodia"),.revision=tsc(L"1.0"),.date=tsc(L"2005-3-15")},.monetary={.int_curr_symbol=tsc(L"KHR "),.currency_symbol=tsc(L"៛"),.mon_decimal_point=tsc(L"."),.mon_thousands_sep=tsc(L","),.mon_grouping={numeric_grouping_storage,1},.positive_sign=tsc(L""),.negative_sign=tsc(L"-"),.int_frac_digits=2,.frac_digits=2,.p_cs_precedes=0,.p_sep_by_space=0,.n_cs_precedes=0,.n_sep_by_space=0,.int_p_cs_precedes=0,.int_p_sep_by_space=0,.int_n_cs_precedes=0,.int_n_sep_by_space=0,.p_sign_posn=1,.n_sign_posn=1,.int_p_sign_posn=1,.int_n_sign_posn=1},.numeric={.decimal_point=tsc(L"."),.thousands_sep=tsc(L","),.grouping={numeric_grouping_storage,1}},.time={.abday={tsc(L"អា"),tsc(L"ច"),tsc(L"អ"),tsc(L"ពុ"),tsc(L"ព្រ"),tsc(L"សុ"),tsc(L"ស")},.day={tsc(L"ថ្ងៃ​អាទិត្យ"),tsc(L"ថ្ងៃ​ច័ន្ទ"),tsc(L"ថ្ងៃ​អង្គារ"),tsc(L"ថ្ងៃ​ពុធ"),tsc(L"ថ្ងៃ​ព្រហស្បតិ៍"),tsc(L"ថ្ងៃ​សុក្រ"),tsc(L"ថ្ងៃ​សៅរ៍")},.abmon={tsc(L"១"),tsc(L"២"),tsc(L"៣"),tsc(L"៤"),tsc(L"៥"),tsc(L"៦"),tsc(L"៧"),tsc(L"៨"),tsc(L"៩"),tsc(L"១០"),tsc(L"១១"),tsc(L"១២")},.mon={tsc(L"មករា"),tsc(L"កុម្ភៈ"),tsc(L"មីនា"),tsc(L"មេសា"),tsc(L"ឧសភា"),tsc(L"មិថុនា"),tsc(L"កក្កដា"),tsc(L"សីហា"),tsc(L"កញ្ញា"),tsc(L"តុលា"),tsc(L"វិច្ឆិកា"),tsc(L"ធ្នូ")},.d_t_fmt=tsc(L"%A ថ្ងៃ %e ខែ %B ឆ្នាំ %Y, %H ម៉ោង %M នាទី %S វិនាទី​"),.d_fmt=tsc(L"%e %B %Y"),.t_fmt=tsc(L"%H:%M:%S"),.date_fmt=tsc(L"%A ថ្ងៃ %e ខែ %B ឆ្នាំ %Y, %H ម៉ោង %M នាទី %S វិនាទី​"),.am_pm={tsc(L"ព្រឹក"),tsc(L"ល្ងាច")},.week={7,19971130,1},.first_weekday=1},.messages={.yesexpr=tsc(L"^[+1yYប]"),.noexpr=tsc(L"^[-0nNទ]"),.yesstr=tsc(L"បាទ/ចាស"),.nostr=tsc(L"ទេ")},.paper={.width=210,.height=297},.telephone={.tel_int_fmt=tsc(L"+%c %a %l"),.tel_dom_fmt=tsc(L"(%A)%l"),.int_select=tsc(L"001"),.int_prefix=tsc(L"855")},.name={.name_fmt=tsc(L"%d%t%g%t%m%t%f")},.address={.postal_fmt=tsc(L"%f%N%a%N%d%N%r%t%e%t%b%N%h%t%s%N%T%N%S%N%z%c%N"),.country_name=tsc(L"កម្ពុជា"),.country_ab2=tsc(L"KH"),.country_ab3=tsc(L"KHM"),.country_num=116,.country_car=tsc(L"KH"),.lang_name=tsc(L"ខ្មែរ"),.lang_ab=tsc(L"km"),.lang_term=tsc(L"khm"),.lang_lib=tsc(L"khm")},.measurement={.measurement=1}};

inline constexpr u8lc_all u8lc_all_global{.identification={.name=tsc(u8"km_KH"),.encoding=tsc(FAST_IO_LOCALE_u8ENCODING),.title=tsc(u8"Khmer locale for Cambodia"),.source=tsc(u8"fast_io"),.address=tsc(u8"https://gitee.com/qabeowjbtkwb/fast_io\t\t;\t\thttps://github.com/cppfastio/fast_io"),.contact=tsc(u8"Jens Herden at: jens@khmeros.info\t\t;\t\tfast_io"),.email=tsc(u8"bug-glibc-locales@gnu.org;euloanty@live.com"),.tel=tsc(u8""),.fax=tsc(u8""),.language=tsc(u8"Khmer"),.territory=tsc(u8"Cambodia"),.revision=tsc(u8"1.0"),.date=tsc(u8"2005-3-15")},.monetary={.int_curr_symbol=tsc(u8"KHR "),.currency_symbol=tsc(u8"៛"),.mon_decimal_point=tsc(u8"."),.mon_thousands_sep=tsc(u8","),.mon_grouping={numeric_grouping_storage,1},.positive_sign=tsc(u8""),.negative_sign=tsc(u8"-"),.int_frac_digits=2,.frac_digits=2,.p_cs_precedes=0,.p_sep_by_space=0,.n_cs_precedes=0,.n_sep_by_space=0,.int_p_cs_precedes=0,.int_p_sep_by_space=0,.int_n_cs_precedes=0,.int_n_sep_by_space=0,.p_sign_posn=1,.n_sign_posn=1,.int_p_sign_posn=1,.int_n_sign_posn=1},.numeric={.decimal_point=tsc(u8"."),.thousands_sep=tsc(u8","),.grouping={numeric_grouping_storage,1}},.time={.abday={tsc(u8"អា"),tsc(u8"ច"),tsc(u8"អ"),tsc(u8"ពុ"),tsc(u8"ព្រ"),tsc(u8"សុ"),tsc(u8"ស")},.day={tsc(u8"ថ្ងៃ​អាទិត្យ"),tsc(u8"ថ្ងៃ​ច័ន្ទ"),tsc(u8"ថ្ងៃ​អង្គារ"),tsc(u8"ថ្ងៃ​ពុធ"),tsc(u8"ថ្ងៃ​ព្រហស្បតិ៍"),tsc(u8"ថ្ងៃ​សុក្រ"),tsc(u8"ថ្ងៃ​សៅរ៍")},.abmon={tsc(u8"១"),tsc(u8"២"),tsc(u8"៣"),tsc(u8"៤"),tsc(u8"៥"),tsc(u8"៦"),tsc(u8"៧"),tsc(u8"៨"),tsc(u8"៩"),tsc(u8"១០"),tsc(u8"១១"),tsc(u8"១២")},.mon={tsc(u8"មករា"),tsc(u8"កុម្ភៈ"),tsc(u8"មីនា"),tsc(u8"មេសា"),tsc(u8"ឧសភា"),tsc(u8"មិថុនា"),tsc(u8"កក្កដា"),tsc(u8"សីហា"),tsc(u8"កញ្ញា"),tsc(u8"តុលា"),tsc(u8"វិច្ឆិកា"),tsc(u8"ធ្នូ")},.d_t_fmt=tsc(u8"%A ថ្ងៃ %e ខែ %B ឆ្នាំ %Y, %H ម៉ោង %M នាទី %S វិនាទី​"),.d_fmt=tsc(u8"%e %B %Y"),.t_fmt=tsc(u8"%H:%M:%S"),.date_fmt=tsc(u8"%A ថ្ងៃ %e ខែ %B ឆ្នាំ %Y, %H ម៉ោង %M នាទី %S វិនាទី​"),.am_pm={tsc(u8"ព្រឹក"),tsc(u8"ល្ងាច")},.week={7,19971130,1},.first_weekday=1},.messages={.yesexpr=tsc(u8"^[+1yYប]"),.noexpr=tsc(u8"^[-0nNទ]"),.yesstr=tsc(u8"បាទ/ចាស"),.nostr=tsc(u8"ទេ")},.paper={.width=210,.height=297},.telephone={.tel_int_fmt=tsc(u8"+%c %a %l"),.tel_dom_fmt=tsc(u8"(%A)%l"),.int_select=tsc(u8"001"),.int_prefix=tsc(u8"855")},.name={.name_fmt=tsc(u8"%d%t%g%t%m%t%f")},.address={.postal_fmt=tsc(u8"%f%N%a%N%d%N%r%t%e%t%b%N%h%t%s%N%T%N%S%N%z%c%N"),.country_name=tsc(u8"កម្ពុជា"),.country_ab2=tsc(u8"KH"),.country_ab3=tsc(u8"KHM"),.country_num=116,.country_car=tsc(u8"KH"),.lang_name=tsc(u8"ខ្មែរ"),.lang_ab=tsc(u8"km"),.lang_term=tsc(u8"khm"),.lang_lib=tsc(u8"khm")},.measurement={.measurement=1}};

inline constexpr u16lc_all u16lc_all_global{.identification={.name=tsc(u"km_KH"),.encoding=tsc(FAST_IO_LOCALE_uENCODING),.title=tsc(u"Khmer locale for Cambodia"),.source=tsc(u"fast_io"),.address=tsc(u"https://gitee.com/qabeowjbtkwb/fast_io\t\t;\t\thttps://github.com/cppfastio/fast_io"),.contact=tsc(u"Jens Herden at: jens@khmeros.info\t\t;\t\tfast_io"),.email=tsc(u"bug-glibc-locales@gnu.org;euloanty@live.com"),.tel=tsc(u""),.fax=tsc(u""),.language=tsc(u"Khmer"),.territory=tsc(u"Cambodia"),.revision=tsc(u"1.0"),.date=tsc(u"2005-3-15")},.monetary={.int_curr_symbol=tsc(u"KHR "),.currency_symbol=tsc(u"៛"),.mon_decimal_point=tsc(u"."),.mon_thousands_sep=tsc(u","),.mon_grouping={numeric_grouping_storage,1},.positive_sign=tsc(u""),.negative_sign=tsc(u"-"),.int_frac_digits=2,.frac_digits=2,.p_cs_precedes=0,.p_sep_by_space=0,.n_cs_precedes=0,.n_sep_by_space=0,.int_p_cs_precedes=0,.int_p_sep_by_space=0,.int_n_cs_precedes=0,.int_n_sep_by_space=0,.p_sign_posn=1,.n_sign_posn=1,.int_p_sign_posn=1,.int_n_sign_posn=1},.numeric={.decimal_point=tsc(u"."),.thousands_sep=tsc(u","),.grouping={numeric_grouping_storage,1}},.time={.abday={tsc(u"អា"),tsc(u"ច"),tsc(u"អ"),tsc(u"ពុ"),tsc(u"ព្រ"),tsc(u"សុ"),tsc(u"ស")},.day={tsc(u"ថ្ងៃ​អាទិត្យ"),tsc(u"ថ្ងៃ​ច័ន្ទ"),tsc(u"ថ្ងៃ​អង្គារ"),tsc(u"ថ្ងៃ​ពុធ"),tsc(u"ថ្ងៃ​ព្រហស្បតិ៍"),tsc(u"ថ្ងៃ​សុក្រ"),tsc(u"ថ្ងៃ​សៅរ៍")},.abmon={tsc(u"១"),tsc(u"២"),tsc(u"៣"),tsc(u"៤"),tsc(u"៥"),tsc(u"៦"),tsc(u"៧"),tsc(u"៨"),tsc(u"៩"),tsc(u"១០"),tsc(u"១១"),tsc(u"១២")},.mon={tsc(u"មករា"),tsc(u"កុម្ភៈ"),tsc(u"មីនា"),tsc(u"មេសា"),tsc(u"ឧសភា"),tsc(u"មិថុនា"),tsc(u"កក្កដា"),tsc(u"សីហា"),tsc(u"កញ្ញា"),tsc(u"តុលា"),tsc(u"វិច្ឆិកា"),tsc(u"ធ្នូ")},.d_t_fmt=tsc(u"%A ថ្ងៃ %e ខែ %B ឆ្នាំ %Y, %H ម៉ោង %M នាទី %S វិនាទី​"),.d_fmt=tsc(u"%e %B %Y"),.t_fmt=tsc(u"%H:%M:%S"),.date_fmt=tsc(u"%A ថ្ងៃ %e ខែ %B ឆ្នាំ %Y, %H ម៉ោង %M នាទី %S វិនាទី​"),.am_pm={tsc(u"ព្រឹក"),tsc(u"ល្ងាច")},.week={7,19971130,1},.first_weekday=1},.messages={.yesexpr=tsc(u"^[+1yYប]"),.noexpr=tsc(u"^[-0nNទ]"),.yesstr=tsc(u"បាទ/ចាស"),.nostr=tsc(u"ទេ")},.paper={.width=210,.height=297},.telephone={.tel_int_fmt=tsc(u"+%c %a %l"),.tel_dom_fmt=tsc(u"(%A)%l"),.int_select=tsc(u"001"),.int_prefix=tsc(u"855")},.name={.name_fmt=tsc(u"%d%t%g%t%m%t%f")},.address={.postal_fmt=tsc(u"%f%N%a%N%d%N%r%t%e%t%b%N%h%t%s%N%T%N%S%N%z%c%N"),.country_name=tsc(u"កម្ពុជា"),.country_ab2=tsc(u"KH"),.country_ab3=tsc(u"KHM"),.country_num=116,.country_car=tsc(u"KH"),.lang_name=tsc(u"ខ្មែរ"),.lang_ab=tsc(u"km"),.lang_term=tsc(u"khm"),.lang_lib=tsc(u"khm")},.measurement={.measurement=1}};

inline constexpr u32lc_all u32lc_all_global{.identification={.name=tsc(U"km_KH"),.encoding=tsc(FAST_IO_LOCALE_UENCODING),.title=tsc(U"Khmer locale for Cambodia"),.source=tsc(U"fast_io"),.address=tsc(U"https://gitee.com/qabeowjbtkwb/fast_io\t\t;\t\thttps://github.com/cppfastio/fast_io"),.contact=tsc(U"Jens Herden at: jens@khmeros.info\t\t;\t\tfast_io"),.email=tsc(U"bug-glibc-locales@gnu.org;euloanty@live.com"),.tel=tsc(U""),.fax=tsc(U""),.language=tsc(U"Khmer"),.territory=tsc(U"Cambodia"),.revision=tsc(U"1.0"),.date=tsc(U"2005-3-15")},.monetary={.int_curr_symbol=tsc(U"KHR "),.currency_symbol=tsc(U"៛"),.mon_decimal_point=tsc(U"."),.mon_thousands_sep=tsc(U","),.mon_grouping={numeric_grouping_storage,1},.positive_sign=tsc(U""),.negative_sign=tsc(U"-"),.int_frac_digits=2,.frac_digits=2,.p_cs_precedes=0,.p_sep_by_space=0,.n_cs_precedes=0,.n_sep_by_space=0,.int_p_cs_precedes=0,.int_p_sep_by_space=0,.int_n_cs_precedes=0,.int_n_sep_by_space=0,.p_sign_posn=1,.n_sign_posn=1,.int_p_sign_posn=1,.int_n_sign_posn=1},.numeric={.decimal_point=tsc(U"."),.thousands_sep=tsc(U","),.grouping={numeric_grouping_storage,1}},.time={.abday={tsc(U"អា"),tsc(U"ច"),tsc(U"អ"),tsc(U"ពុ"),tsc(U"ព្រ"),tsc(U"សុ"),tsc(U"ស")},.day={tsc(U"ថ្ងៃ​អាទិត្យ"),tsc(U"ថ្ងៃ​ច័ន្ទ"),tsc(U"ថ្ងៃ​អង្គារ"),tsc(U"ថ្ងៃ​ពុធ"),tsc(U"ថ្ងៃ​ព្រហស្បតិ៍"),tsc(U"ថ្ងៃ​សុក្រ"),tsc(U"ថ្ងៃ​សៅរ៍")},.abmon={tsc(U"១"),tsc(U"២"),tsc(U"៣"),tsc(U"៤"),tsc(U"៥"),tsc(U"៦"),tsc(U"៧"),tsc(U"៨"),tsc(U"៩"),tsc(U"១០"),tsc(U"១១"),tsc(U"១២")},.mon={tsc(U"មករា"),tsc(U"កុម្ភៈ"),tsc(U"មីនា"),tsc(U"មេសា"),tsc(U"ឧសភា"),tsc(U"មិថុនា"),tsc(U"កក្កដា"),tsc(U"សីហា"),tsc(U"កញ្ញា"),tsc(U"តុលា"),tsc(U"វិច្ឆិកា"),tsc(U"ធ្នូ")},.d_t_fmt=tsc(U"%A ថ្ងៃ %e ខែ %B ឆ្នាំ %Y, %H ម៉ោង %M នាទី %S វិនាទី​"),.d_fmt=tsc(U"%e %B %Y"),.t_fmt=tsc(U"%H:%M:%S"),.date_fmt=tsc(U"%A ថ្ងៃ %e ខែ %B ឆ្នាំ %Y, %H ម៉ោង %M នាទី %S វិនាទី​"),.am_pm={tsc(U"ព្រឹក"),tsc(U"ល្ងាច")},.week={7,19971130,1},.first_weekday=1},.messages={.yesexpr=tsc(U"^[+1yYប]"),.noexpr=tsc(U"^[-0nNទ]"),.yesstr=tsc(U"បាទ/ចាស"),.nostr=tsc(U"ទេ")},.paper={.width=210,.height=297},.telephone={.tel_int_fmt=tsc(U"+%c %a %l"),.tel_dom_fmt=tsc(U"(%A)%l"),.int_select=tsc(U"001"),.int_prefix=tsc(U"855")},.name={.name_fmt=tsc(U"%d%t%g%t%m%t%f")},.address={.postal_fmt=tsc(U"%f%N%a%N%d%N%r%t%e%t%b%N%h%t%s%N%T%N%S%N%z%c%N"),.country_name=tsc(U"កម្ពុជា"),.country_ab2=tsc(U"KH"),.country_ab3=tsc(U"KHM"),.country_num=116,.country_car=tsc(U"KH"),.lang_name=tsc(U"ខ្មែរ"),.lang_ab=tsc(U"km"),.lang_term=tsc(U"khm"),.lang_lib=tsc(U"khm")},.measurement={.measurement=1}};


}
}

#include"../main.h"