﻿#include"../localedef.h"

namespace fast_io_i18n
{
namespace
{

inline constexpr std::size_t monetary_mon_grouping_storage[]{3,2};

inline constexpr std::size_t numeric_grouping_storage[]{3};

inline constexpr lc_all lc_all_global{.identification={.name=tsc("sa_IN"),.encoding=tsc(FAST_IO_LOCALE_ENCODING),.title=tsc("Sanskrit language locale for India"),.source=tsc("The Debian project\t\t;\t\tfast_io"),.address=tsc("https://gitee.com/qabeowjbtkwb/fast_io\t\t;\t\thttps://github.com/cppfastio/fast_io"),.contact=tsc("Christian Perrier\t\t;\t\tfast_io"),.email=tsc("bubulle@debian.org;euloanty@live.com"),.tel=tsc(""),.fax=tsc(""),.language=tsc("Sanskrit"),.territory=tsc("India"),.revision=tsc("1.0"),.date=tsc("2005-09-25")},.monetary={.int_curr_symbol=tsc("INR "),.currency_symbol=tsc("₹"),.mon_decimal_point=tsc("."),.mon_thousands_sep=tsc(","),.mon_grouping={monetary_mon_grouping_storage,2},.positive_sign=tsc(""),.negative_sign=tsc("-"),.int_frac_digits=2,.frac_digits=2,.p_cs_precedes=1,.p_sep_by_space=0,.n_cs_precedes=1,.n_sep_by_space=0,.p_sign_posn=1,.n_sign_posn=1},.numeric={.decimal_point=tsc("."),.thousands_sep=tsc(","),.grouping={numeric_grouping_storage,1}},.time={.abday={tsc("रविः"),tsc("सोम:"),tsc("मंगल:"),tsc("बुध:"),tsc("बृहस्पतिः"),tsc("शुक्र"),tsc("शनि:")},.day={tsc("रविवासर:"),tsc("सोमवासर:"),tsc("मंगलवासर:"),tsc("बुधवासर:"),tsc("बृहस्पतिवासरः"),tsc("शुक्रवासर"),tsc("शनिवासर:")},.abmon={tsc("जनवरी"),tsc("फ़रवरी"),tsc("मार्च"),tsc("अप्रेल"),tsc("मई"),tsc("जून"),tsc("जुलाई"),tsc("अगस्त"),tsc("सितम्बर"),tsc("अक्टूबर"),tsc("नवम्बर"),tsc("दिसम्बर")},.mon={tsc("जनवरी"),tsc("फ़रवरी"),tsc("मार्च"),tsc("अप्रेल"),tsc("मई"),tsc("जून"),tsc("जुलाई"),tsc("अगस्त"),tsc("सितम्बर"),tsc("अक्टूबर"),tsc("नवम्बर"),tsc("दिसम्बर")},.d_t_fmt=tsc("%A %d %b %Y %I:%M:%S %p"),.d_fmt=tsc("%-d-%m-%y"),.t_fmt=tsc("%I:%M:%S %p %Z"),.t_fmt_ampm=tsc("%I:%M:%S %p %Z"),.date_fmt=tsc("%A %d %b %Y %I:%M:%S %p %Z"),.am_pm={tsc("पूर्वाह्न"),tsc("अपराह्न")},.week={7,19971130,1}},.messages={.yesexpr=tsc("^[+1aAyYआ]"),.noexpr=tsc("^[-0nNन]"),.yesstr=tsc("आम्"),.nostr=tsc("न")},.paper={.width=210,.height=297},.telephone={.tel_int_fmt=tsc("+%c ;%a ;%l"),.int_select=tsc("00"),.int_prefix=tsc("91")},.name={.name_fmt=tsc("%p%t%f%t%g"),.name_gen=tsc(""),.name_miss=tsc("कुमारी"),.name_mr=tsc("श्री"),.name_mrs=tsc("श्रीमती"),.name_ms=tsc("श्रीमती")},.address={.postal_fmt=tsc("%z%c%T%s%b%e%r"),.country_name=tsc("भारतम्"),.country_ab2=tsc("IN"),.country_ab3=tsc("IND"),.country_num=356,.country_car=tsc("IND"),.lang_name=tsc("संस्कृतम्"),.lang_ab=tsc("sa"),.lang_term=tsc("san"),.lang_lib=tsc("san")},.measurement={.measurement=1}};

inline constexpr wlc_all wlc_all_global{.identification={.name=tsc(L"sa_IN"),.encoding=tsc(FAST_IO_LOCALE_LENCODING),.title=tsc(L"Sanskrit language locale for India"),.source=tsc(L"The Debian project\t\t;\t\tfast_io"),.address=tsc(L"https://gitee.com/qabeowjbtkwb/fast_io\t\t;\t\thttps://github.com/cppfastio/fast_io"),.contact=tsc(L"Christian Perrier\t\t;\t\tfast_io"),.email=tsc(L"bubulle@debian.org;euloanty@live.com"),.tel=tsc(L""),.fax=tsc(L""),.language=tsc(L"Sanskrit"),.territory=tsc(L"India"),.revision=tsc(L"1.0"),.date=tsc(L"2005-09-25")},.monetary={.int_curr_symbol=tsc(L"INR "),.currency_symbol=tsc(L"₹"),.mon_decimal_point=tsc(L"."),.mon_thousands_sep=tsc(L","),.mon_grouping={monetary_mon_grouping_storage,2},.positive_sign=tsc(L""),.negative_sign=tsc(L"-"),.int_frac_digits=2,.frac_digits=2,.p_cs_precedes=1,.p_sep_by_space=0,.n_cs_precedes=1,.n_sep_by_space=0,.p_sign_posn=1,.n_sign_posn=1},.numeric={.decimal_point=tsc(L"."),.thousands_sep=tsc(L","),.grouping={numeric_grouping_storage,1}},.time={.abday={tsc(L"रविः"),tsc(L"सोम:"),tsc(L"मंगल:"),tsc(L"बुध:"),tsc(L"बृहस्पतिः"),tsc(L"शुक्र"),tsc(L"शनि:")},.day={tsc(L"रविवासर:"),tsc(L"सोमवासर:"),tsc(L"मंगलवासर:"),tsc(L"बुधवासर:"),tsc(L"बृहस्पतिवासरः"),tsc(L"शुक्रवासर"),tsc(L"शनिवासर:")},.abmon={tsc(L"जनवरी"),tsc(L"फ़रवरी"),tsc(L"मार्च"),tsc(L"अप्रेल"),tsc(L"मई"),tsc(L"जून"),tsc(L"जुलाई"),tsc(L"अगस्त"),tsc(L"सितम्बर"),tsc(L"अक्टूबर"),tsc(L"नवम्बर"),tsc(L"दिसम्बर")},.mon={tsc(L"जनवरी"),tsc(L"फ़रवरी"),tsc(L"मार्च"),tsc(L"अप्रेल"),tsc(L"मई"),tsc(L"जून"),tsc(L"जुलाई"),tsc(L"अगस्त"),tsc(L"सितम्बर"),tsc(L"अक्टूबर"),tsc(L"नवम्बर"),tsc(L"दिसम्बर")},.d_t_fmt=tsc(L"%A %d %b %Y %I:%M:%S %p"),.d_fmt=tsc(L"%-d-%m-%y"),.t_fmt=tsc(L"%I:%M:%S %p %Z"),.t_fmt_ampm=tsc(L"%I:%M:%S %p %Z"),.date_fmt=tsc(L"%A %d %b %Y %I:%M:%S %p %Z"),.am_pm={tsc(L"पूर्वाह्न"),tsc(L"अपराह्न")},.week={7,19971130,1}},.messages={.yesexpr=tsc(L"^[+1aAyYआ]"),.noexpr=tsc(L"^[-0nNन]"),.yesstr=tsc(L"आम्"),.nostr=tsc(L"न")},.paper={.width=210,.height=297},.telephone={.tel_int_fmt=tsc(L"+%c ;%a ;%l"),.int_select=tsc(L"00"),.int_prefix=tsc(L"91")},.name={.name_fmt=tsc(L"%p%t%f%t%g"),.name_gen=tsc(L""),.name_miss=tsc(L"कुमारी"),.name_mr=tsc(L"श्री"),.name_mrs=tsc(L"श्रीमती"),.name_ms=tsc(L"श्रीमती")},.address={.postal_fmt=tsc(L"%z%c%T%s%b%e%r"),.country_name=tsc(L"भारतम्"),.country_ab2=tsc(L"IN"),.country_ab3=tsc(L"IND"),.country_num=356,.country_car=tsc(L"IND"),.lang_name=tsc(L"संस्कृतम्"),.lang_ab=tsc(L"sa"),.lang_term=tsc(L"san"),.lang_lib=tsc(L"san")},.measurement={.measurement=1}};

inline constexpr u8lc_all u8lc_all_global{.identification={.name=tsc(u8"sa_IN"),.encoding=tsc(FAST_IO_LOCALE_u8ENCODING),.title=tsc(u8"Sanskrit language locale for India"),.source=tsc(u8"The Debian project\t\t;\t\tfast_io"),.address=tsc(u8"https://gitee.com/qabeowjbtkwb/fast_io\t\t;\t\thttps://github.com/cppfastio/fast_io"),.contact=tsc(u8"Christian Perrier\t\t;\t\tfast_io"),.email=tsc(u8"bubulle@debian.org;euloanty@live.com"),.tel=tsc(u8""),.fax=tsc(u8""),.language=tsc(u8"Sanskrit"),.territory=tsc(u8"India"),.revision=tsc(u8"1.0"),.date=tsc(u8"2005-09-25")},.monetary={.int_curr_symbol=tsc(u8"INR "),.currency_symbol=tsc(u8"₹"),.mon_decimal_point=tsc(u8"."),.mon_thousands_sep=tsc(u8","),.mon_grouping={monetary_mon_grouping_storage,2},.positive_sign=tsc(u8""),.negative_sign=tsc(u8"-"),.int_frac_digits=2,.frac_digits=2,.p_cs_precedes=1,.p_sep_by_space=0,.n_cs_precedes=1,.n_sep_by_space=0,.p_sign_posn=1,.n_sign_posn=1},.numeric={.decimal_point=tsc(u8"."),.thousands_sep=tsc(u8","),.grouping={numeric_grouping_storage,1}},.time={.abday={tsc(u8"रविः"),tsc(u8"सोम:"),tsc(u8"मंगल:"),tsc(u8"बुध:"),tsc(u8"बृहस्पतिः"),tsc(u8"शुक्र"),tsc(u8"शनि:")},.day={tsc(u8"रविवासर:"),tsc(u8"सोमवासर:"),tsc(u8"मंगलवासर:"),tsc(u8"बुधवासर:"),tsc(u8"बृहस्पतिवासरः"),tsc(u8"शुक्रवासर"),tsc(u8"शनिवासर:")},.abmon={tsc(u8"जनवरी"),tsc(u8"फ़रवरी"),tsc(u8"मार्च"),tsc(u8"अप्रेल"),tsc(u8"मई"),tsc(u8"जून"),tsc(u8"जुलाई"),tsc(u8"अगस्त"),tsc(u8"सितम्बर"),tsc(u8"अक्टूबर"),tsc(u8"नवम्बर"),tsc(u8"दिसम्बर")},.mon={tsc(u8"जनवरी"),tsc(u8"फ़रवरी"),tsc(u8"मार्च"),tsc(u8"अप्रेल"),tsc(u8"मई"),tsc(u8"जून"),tsc(u8"जुलाई"),tsc(u8"अगस्त"),tsc(u8"सितम्बर"),tsc(u8"अक्टूबर"),tsc(u8"नवम्बर"),tsc(u8"दिसम्बर")},.d_t_fmt=tsc(u8"%A %d %b %Y %I:%M:%S %p"),.d_fmt=tsc(u8"%-d-%m-%y"),.t_fmt=tsc(u8"%I:%M:%S %p %Z"),.t_fmt_ampm=tsc(u8"%I:%M:%S %p %Z"),.date_fmt=tsc(u8"%A %d %b %Y %I:%M:%S %p %Z"),.am_pm={tsc(u8"पूर्वाह्न"),tsc(u8"अपराह्न")},.week={7,19971130,1}},.messages={.yesexpr=tsc(u8"^[+1aAyYआ]"),.noexpr=tsc(u8"^[-0nNन]"),.yesstr=tsc(u8"आम्"),.nostr=tsc(u8"न")},.paper={.width=210,.height=297},.telephone={.tel_int_fmt=tsc(u8"+%c ;%a ;%l"),.int_select=tsc(u8"00"),.int_prefix=tsc(u8"91")},.name={.name_fmt=tsc(u8"%p%t%f%t%g"),.name_gen=tsc(u8""),.name_miss=tsc(u8"कुमारी"),.name_mr=tsc(u8"श्री"),.name_mrs=tsc(u8"श्रीमती"),.name_ms=tsc(u8"श्रीमती")},.address={.postal_fmt=tsc(u8"%z%c%T%s%b%e%r"),.country_name=tsc(u8"भारतम्"),.country_ab2=tsc(u8"IN"),.country_ab3=tsc(u8"IND"),.country_num=356,.country_car=tsc(u8"IND"),.lang_name=tsc(u8"संस्कृतम्"),.lang_ab=tsc(u8"sa"),.lang_term=tsc(u8"san"),.lang_lib=tsc(u8"san")},.measurement={.measurement=1}};

inline constexpr u16lc_all u16lc_all_global{.identification={.name=tsc(u"sa_IN"),.encoding=tsc(FAST_IO_LOCALE_uENCODING),.title=tsc(u"Sanskrit language locale for India"),.source=tsc(u"The Debian project\t\t;\t\tfast_io"),.address=tsc(u"https://gitee.com/qabeowjbtkwb/fast_io\t\t;\t\thttps://github.com/cppfastio/fast_io"),.contact=tsc(u"Christian Perrier\t\t;\t\tfast_io"),.email=tsc(u"bubulle@debian.org;euloanty@live.com"),.tel=tsc(u""),.fax=tsc(u""),.language=tsc(u"Sanskrit"),.territory=tsc(u"India"),.revision=tsc(u"1.0"),.date=tsc(u"2005-09-25")},.monetary={.int_curr_symbol=tsc(u"INR "),.currency_symbol=tsc(u"₹"),.mon_decimal_point=tsc(u"."),.mon_thousands_sep=tsc(u","),.mon_grouping={monetary_mon_grouping_storage,2},.positive_sign=tsc(u""),.negative_sign=tsc(u"-"),.int_frac_digits=2,.frac_digits=2,.p_cs_precedes=1,.p_sep_by_space=0,.n_cs_precedes=1,.n_sep_by_space=0,.p_sign_posn=1,.n_sign_posn=1},.numeric={.decimal_point=tsc(u"."),.thousands_sep=tsc(u","),.grouping={numeric_grouping_storage,1}},.time={.abday={tsc(u"रविः"),tsc(u"सोम:"),tsc(u"मंगल:"),tsc(u"बुध:"),tsc(u"बृहस्पतिः"),tsc(u"शुक्र"),tsc(u"शनि:")},.day={tsc(u"रविवासर:"),tsc(u"सोमवासर:"),tsc(u"मंगलवासर:"),tsc(u"बुधवासर:"),tsc(u"बृहस्पतिवासरः"),tsc(u"शुक्रवासर"),tsc(u"शनिवासर:")},.abmon={tsc(u"जनवरी"),tsc(u"फ़रवरी"),tsc(u"मार्च"),tsc(u"अप्रेल"),tsc(u"मई"),tsc(u"जून"),tsc(u"जुलाई"),tsc(u"अगस्त"),tsc(u"सितम्बर"),tsc(u"अक्टूबर"),tsc(u"नवम्बर"),tsc(u"दिसम्बर")},.mon={tsc(u"जनवरी"),tsc(u"फ़रवरी"),tsc(u"मार्च"),tsc(u"अप्रेल"),tsc(u"मई"),tsc(u"जून"),tsc(u"जुलाई"),tsc(u"अगस्त"),tsc(u"सितम्बर"),tsc(u"अक्टूबर"),tsc(u"नवम्बर"),tsc(u"दिसम्बर")},.d_t_fmt=tsc(u"%A %d %b %Y %I:%M:%S %p"),.d_fmt=tsc(u"%-d-%m-%y"),.t_fmt=tsc(u"%I:%M:%S %p %Z"),.t_fmt_ampm=tsc(u"%I:%M:%S %p %Z"),.date_fmt=tsc(u"%A %d %b %Y %I:%M:%S %p %Z"),.am_pm={tsc(u"पूर्वाह्न"),tsc(u"अपराह्न")},.week={7,19971130,1}},.messages={.yesexpr=tsc(u"^[+1aAyYआ]"),.noexpr=tsc(u"^[-0nNन]"),.yesstr=tsc(u"आम्"),.nostr=tsc(u"न")},.paper={.width=210,.height=297},.telephone={.tel_int_fmt=tsc(u"+%c ;%a ;%l"),.int_select=tsc(u"00"),.int_prefix=tsc(u"91")},.name={.name_fmt=tsc(u"%p%t%f%t%g"),.name_gen=tsc(u""),.name_miss=tsc(u"कुमारी"),.name_mr=tsc(u"श्री"),.name_mrs=tsc(u"श्रीमती"),.name_ms=tsc(u"श्रीमती")},.address={.postal_fmt=tsc(u"%z%c%T%s%b%e%r"),.country_name=tsc(u"भारतम्"),.country_ab2=tsc(u"IN"),.country_ab3=tsc(u"IND"),.country_num=356,.country_car=tsc(u"IND"),.lang_name=tsc(u"संस्कृतम्"),.lang_ab=tsc(u"sa"),.lang_term=tsc(u"san"),.lang_lib=tsc(u"san")},.measurement={.measurement=1}};

inline constexpr u32lc_all u32lc_all_global{.identification={.name=tsc(U"sa_IN"),.encoding=tsc(FAST_IO_LOCALE_UENCODING),.title=tsc(U"Sanskrit language locale for India"),.source=tsc(U"The Debian project\t\t;\t\tfast_io"),.address=tsc(U"https://gitee.com/qabeowjbtkwb/fast_io\t\t;\t\thttps://github.com/cppfastio/fast_io"),.contact=tsc(U"Christian Perrier\t\t;\t\tfast_io"),.email=tsc(U"bubulle@debian.org;euloanty@live.com"),.tel=tsc(U""),.fax=tsc(U""),.language=tsc(U"Sanskrit"),.territory=tsc(U"India"),.revision=tsc(U"1.0"),.date=tsc(U"2005-09-25")},.monetary={.int_curr_symbol=tsc(U"INR "),.currency_symbol=tsc(U"₹"),.mon_decimal_point=tsc(U"."),.mon_thousands_sep=tsc(U","),.mon_grouping={monetary_mon_grouping_storage,2},.positive_sign=tsc(U""),.negative_sign=tsc(U"-"),.int_frac_digits=2,.frac_digits=2,.p_cs_precedes=1,.p_sep_by_space=0,.n_cs_precedes=1,.n_sep_by_space=0,.p_sign_posn=1,.n_sign_posn=1},.numeric={.decimal_point=tsc(U"."),.thousands_sep=tsc(U","),.grouping={numeric_grouping_storage,1}},.time={.abday={tsc(U"रविः"),tsc(U"सोम:"),tsc(U"मंगल:"),tsc(U"बुध:"),tsc(U"बृहस्पतिः"),tsc(U"शुक्र"),tsc(U"शनि:")},.day={tsc(U"रविवासर:"),tsc(U"सोमवासर:"),tsc(U"मंगलवासर:"),tsc(U"बुधवासर:"),tsc(U"बृहस्पतिवासरः"),tsc(U"शुक्रवासर"),tsc(U"शनिवासर:")},.abmon={tsc(U"जनवरी"),tsc(U"फ़रवरी"),tsc(U"मार्च"),tsc(U"अप्रेल"),tsc(U"मई"),tsc(U"जून"),tsc(U"जुलाई"),tsc(U"अगस्त"),tsc(U"सितम्बर"),tsc(U"अक्टूबर"),tsc(U"नवम्बर"),tsc(U"दिसम्बर")},.mon={tsc(U"जनवरी"),tsc(U"फ़रवरी"),tsc(U"मार्च"),tsc(U"अप्रेल"),tsc(U"मई"),tsc(U"जून"),tsc(U"जुलाई"),tsc(U"अगस्त"),tsc(U"सितम्बर"),tsc(U"अक्टूबर"),tsc(U"नवम्बर"),tsc(U"दिसम्बर")},.d_t_fmt=tsc(U"%A %d %b %Y %I:%M:%S %p"),.d_fmt=tsc(U"%-d-%m-%y"),.t_fmt=tsc(U"%I:%M:%S %p %Z"),.t_fmt_ampm=tsc(U"%I:%M:%S %p %Z"),.date_fmt=tsc(U"%A %d %b %Y %I:%M:%S %p %Z"),.am_pm={tsc(U"पूर्वाह्न"),tsc(U"अपराह्न")},.week={7,19971130,1}},.messages={.yesexpr=tsc(U"^[+1aAyYआ]"),.noexpr=tsc(U"^[-0nNन]"),.yesstr=tsc(U"आम्"),.nostr=tsc(U"न")},.paper={.width=210,.height=297},.telephone={.tel_int_fmt=tsc(U"+%c ;%a ;%l"),.int_select=tsc(U"00"),.int_prefix=tsc(U"91")},.name={.name_fmt=tsc(U"%p%t%f%t%g"),.name_gen=tsc(U""),.name_miss=tsc(U"कुमारी"),.name_mr=tsc(U"श्री"),.name_mrs=tsc(U"श्रीमती"),.name_ms=tsc(U"श्रीमती")},.address={.postal_fmt=tsc(U"%z%c%T%s%b%e%r"),.country_name=tsc(U"भारतम्"),.country_ab2=tsc(U"IN"),.country_ab3=tsc(U"IND"),.country_num=356,.country_car=tsc(U"IND"),.lang_name=tsc(U"संस्कृतम्"),.lang_ab=tsc(U"sa"),.lang_term=tsc(U"san"),.lang_lib=tsc(U"san")},.measurement={.measurement=1}};


}
}

#include"../main.h"