﻿#include"../localedef.h"

namespace fast_io_i18n
{
namespace
{

inline constexpr std::size_t monetary_mon_grouping_storage[]{3,2};

inline constexpr std::size_t numeric_grouping_storage[]{3};

inline constexpr lc_all lc_all_global{.identification={.name=tsc("ur_IN"),.encoding=tsc(FAST_IO_LOCALE_ENCODING),.title=tsc("Urdu language locale for India"),.source=tsc("Red Hat, Pune\t\t;\t\tfast_io"),.address=tsc("Marisfot III, Marigold Premises, East-Wing, Kalyaninagar, Pune, India-411014\t\t;\t\thttps://gitee.com/qabeowjbtkwb/fast_io\t\t;\t\thttps://github.com/cppfastio/fast_io"),.contact=tsc("fast_io"),.email=tsc("bug-glibc-locales@gnu.org;euloanty@live.com"),.tel=tsc(""),.fax=tsc(""),.language=tsc("Urdu"),.territory=tsc("India"),.revision=tsc("1.0"),.date=tsc("2009,June,09")},.monetary={.int_curr_symbol=tsc("INR "),.currency_symbol=tsc("₹"),.mon_decimal_point=tsc("."),.mon_thousands_sep=tsc(","),.mon_grouping={monetary_mon_grouping_storage,2},.positive_sign=tsc(""),.negative_sign=tsc("-"),.int_frac_digits=2,.frac_digits=2,.p_cs_precedes=1,.p_sep_by_space=0,.n_cs_precedes=1,.n_sep_by_space=0,.p_sign_posn=1,.n_sign_posn=1},.numeric={.decimal_point=tsc("."),.thousands_sep=tsc(","),.grouping={numeric_grouping_storage,1}},.time={.abday={tsc("اتوار"),tsc("پیر"),tsc("منگل"),tsc("بدھ"),tsc("جمعرات"),tsc("جمعہ"),tsc("سنیچر")},.day={tsc("اتوار"),tsc("پیر"),tsc("منگل"),tsc("بدھ"),tsc("جمعرات"),tsc("جمعہ"),tsc("سنیچر")},.abmon={tsc("جنوری"),tsc("فروری"),tsc("مارچ"),tsc("اپریل"),tsc("مئی"),tsc("جون"),tsc("جولائی"),tsc("اگست"),tsc("ستمبر"),tsc("اکتوبر"),tsc("نومبر"),tsc("دسمبر")},.mon={tsc("جنوری"),tsc("فروری"),tsc("مارچ"),tsc("اپریل"),tsc("مئی"),tsc("جون"),tsc("جولائی"),tsc("اگست"),tsc("ستمبر"),tsc("اکتوبر"),tsc("نومبر"),tsc("دسمبر")},.d_t_fmt=tsc("%A %d %b %Y %I:%M:%S %p"),.d_fmt=tsc("%-d//%-m//%y"),.t_fmt=tsc("%I:%M:%S %p %Z"),.t_fmt_ampm=tsc("%I:%M:%S %p %Z"),.date_fmt=tsc("%A %d %b %Y %I:%M:%S %p %Z"),.am_pm={tsc("AM"),tsc("PM")},.week={7,19971130,1}},.messages={.yesexpr=tsc("^[+1yYہ]"),.noexpr=tsc("^[-0nNن]"),.yesstr=tsc("ہاں"),.nostr=tsc("نہیں")},.paper={.width=210,.height=297},.telephone={.tel_int_fmt=tsc("+%c ;%a ;%l"),.int_select=tsc("00"),.int_prefix=tsc("91")},.name={.name_fmt=tsc("%p%t%f%t%g"),.name_gen=tsc(""),.name_miss=tsc("ڪماري"),.name_mr=tsc("جناب"),.name_mrs=tsc("محترمہ"),.name_ms=tsc("ڪمار")},.address={.postal_fmt=tsc("%z%c%T%s%b%e%r"),.country_name=tsc("بھارت"),.country_ab2=tsc("IN"),.country_ab3=tsc("IND"),.country_num=356,.country_car=tsc("IND"),.lang_name=tsc("اردو"),.lang_ab=tsc("ur"),.lang_term=tsc("urd"),.lang_lib=tsc("urd")},.measurement={.measurement=1}};

inline constexpr wlc_all wlc_all_global{.identification={.name=tsc(L"ur_IN"),.encoding=tsc(FAST_IO_LOCALE_LENCODING),.title=tsc(L"Urdu language locale for India"),.source=tsc(L"Red Hat, Pune\t\t;\t\tfast_io"),.address=tsc(L"Marisfot III, Marigold Premises, East-Wing, Kalyaninagar, Pune, India-411014\t\t;\t\thttps://gitee.com/qabeowjbtkwb/fast_io\t\t;\t\thttps://github.com/cppfastio/fast_io"),.contact=tsc(L"fast_io"),.email=tsc(L"bug-glibc-locales@gnu.org;euloanty@live.com"),.tel=tsc(L""),.fax=tsc(L""),.language=tsc(L"Urdu"),.territory=tsc(L"India"),.revision=tsc(L"1.0"),.date=tsc(L"2009,June,09")},.monetary={.int_curr_symbol=tsc(L"INR "),.currency_symbol=tsc(L"₹"),.mon_decimal_point=tsc(L"."),.mon_thousands_sep=tsc(L","),.mon_grouping={monetary_mon_grouping_storage,2},.positive_sign=tsc(L""),.negative_sign=tsc(L"-"),.int_frac_digits=2,.frac_digits=2,.p_cs_precedes=1,.p_sep_by_space=0,.n_cs_precedes=1,.n_sep_by_space=0,.p_sign_posn=1,.n_sign_posn=1},.numeric={.decimal_point=tsc(L"."),.thousands_sep=tsc(L","),.grouping={numeric_grouping_storage,1}},.time={.abday={tsc(L"اتوار"),tsc(L"پیر"),tsc(L"منگل"),tsc(L"بدھ"),tsc(L"جمعرات"),tsc(L"جمعہ"),tsc(L"سنیچر")},.day={tsc(L"اتوار"),tsc(L"پیر"),tsc(L"منگل"),tsc(L"بدھ"),tsc(L"جمعرات"),tsc(L"جمعہ"),tsc(L"سنیچر")},.abmon={tsc(L"جنوری"),tsc(L"فروری"),tsc(L"مارچ"),tsc(L"اپریل"),tsc(L"مئی"),tsc(L"جون"),tsc(L"جولائی"),tsc(L"اگست"),tsc(L"ستمبر"),tsc(L"اکتوبر"),tsc(L"نومبر"),tsc(L"دسمبر")},.mon={tsc(L"جنوری"),tsc(L"فروری"),tsc(L"مارچ"),tsc(L"اپریل"),tsc(L"مئی"),tsc(L"جون"),tsc(L"جولائی"),tsc(L"اگست"),tsc(L"ستمبر"),tsc(L"اکتوبر"),tsc(L"نومبر"),tsc(L"دسمبر")},.d_t_fmt=tsc(L"%A %d %b %Y %I:%M:%S %p"),.d_fmt=tsc(L"%-d//%-m//%y"),.t_fmt=tsc(L"%I:%M:%S %p %Z"),.t_fmt_ampm=tsc(L"%I:%M:%S %p %Z"),.date_fmt=tsc(L"%A %d %b %Y %I:%M:%S %p %Z"),.am_pm={tsc(L"AM"),tsc(L"PM")},.week={7,19971130,1}},.messages={.yesexpr=tsc(L"^[+1yYہ]"),.noexpr=tsc(L"^[-0nNن]"),.yesstr=tsc(L"ہاں"),.nostr=tsc(L"نہیں")},.paper={.width=210,.height=297},.telephone={.tel_int_fmt=tsc(L"+%c ;%a ;%l"),.int_select=tsc(L"00"),.int_prefix=tsc(L"91")},.name={.name_fmt=tsc(L"%p%t%f%t%g"),.name_gen=tsc(L""),.name_miss=tsc(L"ڪماري"),.name_mr=tsc(L"جناب"),.name_mrs=tsc(L"محترمہ"),.name_ms=tsc(L"ڪمار")},.address={.postal_fmt=tsc(L"%z%c%T%s%b%e%r"),.country_name=tsc(L"بھارت"),.country_ab2=tsc(L"IN"),.country_ab3=tsc(L"IND"),.country_num=356,.country_car=tsc(L"IND"),.lang_name=tsc(L"اردو"),.lang_ab=tsc(L"ur"),.lang_term=tsc(L"urd"),.lang_lib=tsc(L"urd")},.measurement={.measurement=1}};

inline constexpr u8lc_all u8lc_all_global{.identification={.name=tsc(u8"ur_IN"),.encoding=tsc(FAST_IO_LOCALE_u8ENCODING),.title=tsc(u8"Urdu language locale for India"),.source=tsc(u8"Red Hat, Pune\t\t;\t\tfast_io"),.address=tsc(u8"Marisfot III, Marigold Premises, East-Wing, Kalyaninagar, Pune, India-411014\t\t;\t\thttps://gitee.com/qabeowjbtkwb/fast_io\t\t;\t\thttps://github.com/cppfastio/fast_io"),.contact=tsc(u8"fast_io"),.email=tsc(u8"bug-glibc-locales@gnu.org;euloanty@live.com"),.tel=tsc(u8""),.fax=tsc(u8""),.language=tsc(u8"Urdu"),.territory=tsc(u8"India"),.revision=tsc(u8"1.0"),.date=tsc(u8"2009,June,09")},.monetary={.int_curr_symbol=tsc(u8"INR "),.currency_symbol=tsc(u8"₹"),.mon_decimal_point=tsc(u8"."),.mon_thousands_sep=tsc(u8","),.mon_grouping={monetary_mon_grouping_storage,2},.positive_sign=tsc(u8""),.negative_sign=tsc(u8"-"),.int_frac_digits=2,.frac_digits=2,.p_cs_precedes=1,.p_sep_by_space=0,.n_cs_precedes=1,.n_sep_by_space=0,.p_sign_posn=1,.n_sign_posn=1},.numeric={.decimal_point=tsc(u8"."),.thousands_sep=tsc(u8","),.grouping={numeric_grouping_storage,1}},.time={.abday={tsc(u8"اتوار"),tsc(u8"پیر"),tsc(u8"منگل"),tsc(u8"بدھ"),tsc(u8"جمعرات"),tsc(u8"جمعہ"),tsc(u8"سنیچر")},.day={tsc(u8"اتوار"),tsc(u8"پیر"),tsc(u8"منگل"),tsc(u8"بدھ"),tsc(u8"جمعرات"),tsc(u8"جمعہ"),tsc(u8"سنیچر")},.abmon={tsc(u8"جنوری"),tsc(u8"فروری"),tsc(u8"مارچ"),tsc(u8"اپریل"),tsc(u8"مئی"),tsc(u8"جون"),tsc(u8"جولائی"),tsc(u8"اگست"),tsc(u8"ستمبر"),tsc(u8"اکتوبر"),tsc(u8"نومبر"),tsc(u8"دسمبر")},.mon={tsc(u8"جنوری"),tsc(u8"فروری"),tsc(u8"مارچ"),tsc(u8"اپریل"),tsc(u8"مئی"),tsc(u8"جون"),tsc(u8"جولائی"),tsc(u8"اگست"),tsc(u8"ستمبر"),tsc(u8"اکتوبر"),tsc(u8"نومبر"),tsc(u8"دسمبر")},.d_t_fmt=tsc(u8"%A %d %b %Y %I:%M:%S %p"),.d_fmt=tsc(u8"%-d//%-m//%y"),.t_fmt=tsc(u8"%I:%M:%S %p %Z"),.t_fmt_ampm=tsc(u8"%I:%M:%S %p %Z"),.date_fmt=tsc(u8"%A %d %b %Y %I:%M:%S %p %Z"),.am_pm={tsc(u8"AM"),tsc(u8"PM")},.week={7,19971130,1}},.messages={.yesexpr=tsc(u8"^[+1yYہ]"),.noexpr=tsc(u8"^[-0nNن]"),.yesstr=tsc(u8"ہاں"),.nostr=tsc(u8"نہیں")},.paper={.width=210,.height=297},.telephone={.tel_int_fmt=tsc(u8"+%c ;%a ;%l"),.int_select=tsc(u8"00"),.int_prefix=tsc(u8"91")},.name={.name_fmt=tsc(u8"%p%t%f%t%g"),.name_gen=tsc(u8""),.name_miss=tsc(u8"ڪماري"),.name_mr=tsc(u8"جناب"),.name_mrs=tsc(u8"محترمہ"),.name_ms=tsc(u8"ڪمار")},.address={.postal_fmt=tsc(u8"%z%c%T%s%b%e%r"),.country_name=tsc(u8"بھارت"),.country_ab2=tsc(u8"IN"),.country_ab3=tsc(u8"IND"),.country_num=356,.country_car=tsc(u8"IND"),.lang_name=tsc(u8"اردو"),.lang_ab=tsc(u8"ur"),.lang_term=tsc(u8"urd"),.lang_lib=tsc(u8"urd")},.measurement={.measurement=1}};

inline constexpr u16lc_all u16lc_all_global{.identification={.name=tsc(u"ur_IN"),.encoding=tsc(FAST_IO_LOCALE_uENCODING),.title=tsc(u"Urdu language locale for India"),.source=tsc(u"Red Hat, Pune\t\t;\t\tfast_io"),.address=tsc(u"Marisfot III, Marigold Premises, East-Wing, Kalyaninagar, Pune, India-411014\t\t;\t\thttps://gitee.com/qabeowjbtkwb/fast_io\t\t;\t\thttps://github.com/cppfastio/fast_io"),.contact=tsc(u"fast_io"),.email=tsc(u"bug-glibc-locales@gnu.org;euloanty@live.com"),.tel=tsc(u""),.fax=tsc(u""),.language=tsc(u"Urdu"),.territory=tsc(u"India"),.revision=tsc(u"1.0"),.date=tsc(u"2009,June,09")},.monetary={.int_curr_symbol=tsc(u"INR "),.currency_symbol=tsc(u"₹"),.mon_decimal_point=tsc(u"."),.mon_thousands_sep=tsc(u","),.mon_grouping={monetary_mon_grouping_storage,2},.positive_sign=tsc(u""),.negative_sign=tsc(u"-"),.int_frac_digits=2,.frac_digits=2,.p_cs_precedes=1,.p_sep_by_space=0,.n_cs_precedes=1,.n_sep_by_space=0,.p_sign_posn=1,.n_sign_posn=1},.numeric={.decimal_point=tsc(u"."),.thousands_sep=tsc(u","),.grouping={numeric_grouping_storage,1}},.time={.abday={tsc(u"اتوار"),tsc(u"پیر"),tsc(u"منگل"),tsc(u"بدھ"),tsc(u"جمعرات"),tsc(u"جمعہ"),tsc(u"سنیچر")},.day={tsc(u"اتوار"),tsc(u"پیر"),tsc(u"منگل"),tsc(u"بدھ"),tsc(u"جمعرات"),tsc(u"جمعہ"),tsc(u"سنیچر")},.abmon={tsc(u"جنوری"),tsc(u"فروری"),tsc(u"مارچ"),tsc(u"اپریل"),tsc(u"مئی"),tsc(u"جون"),tsc(u"جولائی"),tsc(u"اگست"),tsc(u"ستمبر"),tsc(u"اکتوبر"),tsc(u"نومبر"),tsc(u"دسمبر")},.mon={tsc(u"جنوری"),tsc(u"فروری"),tsc(u"مارچ"),tsc(u"اپریل"),tsc(u"مئی"),tsc(u"جون"),tsc(u"جولائی"),tsc(u"اگست"),tsc(u"ستمبر"),tsc(u"اکتوبر"),tsc(u"نومبر"),tsc(u"دسمبر")},.d_t_fmt=tsc(u"%A %d %b %Y %I:%M:%S %p"),.d_fmt=tsc(u"%-d//%-m//%y"),.t_fmt=tsc(u"%I:%M:%S %p %Z"),.t_fmt_ampm=tsc(u"%I:%M:%S %p %Z"),.date_fmt=tsc(u"%A %d %b %Y %I:%M:%S %p %Z"),.am_pm={tsc(u"AM"),tsc(u"PM")},.week={7,19971130,1}},.messages={.yesexpr=tsc(u"^[+1yYہ]"),.noexpr=tsc(u"^[-0nNن]"),.yesstr=tsc(u"ہاں"),.nostr=tsc(u"نہیں")},.paper={.width=210,.height=297},.telephone={.tel_int_fmt=tsc(u"+%c ;%a ;%l"),.int_select=tsc(u"00"),.int_prefix=tsc(u"91")},.name={.name_fmt=tsc(u"%p%t%f%t%g"),.name_gen=tsc(u""),.name_miss=tsc(u"ڪماري"),.name_mr=tsc(u"جناب"),.name_mrs=tsc(u"محترمہ"),.name_ms=tsc(u"ڪمار")},.address={.postal_fmt=tsc(u"%z%c%T%s%b%e%r"),.country_name=tsc(u"بھارت"),.country_ab2=tsc(u"IN"),.country_ab3=tsc(u"IND"),.country_num=356,.country_car=tsc(u"IND"),.lang_name=tsc(u"اردو"),.lang_ab=tsc(u"ur"),.lang_term=tsc(u"urd"),.lang_lib=tsc(u"urd")},.measurement={.measurement=1}};

inline constexpr u32lc_all u32lc_all_global{.identification={.name=tsc(U"ur_IN"),.encoding=tsc(FAST_IO_LOCALE_UENCODING),.title=tsc(U"Urdu language locale for India"),.source=tsc(U"Red Hat, Pune\t\t;\t\tfast_io"),.address=tsc(U"Marisfot III, Marigold Premises, East-Wing, Kalyaninagar, Pune, India-411014\t\t;\t\thttps://gitee.com/qabeowjbtkwb/fast_io\t\t;\t\thttps://github.com/cppfastio/fast_io"),.contact=tsc(U"fast_io"),.email=tsc(U"bug-glibc-locales@gnu.org;euloanty@live.com"),.tel=tsc(U""),.fax=tsc(U""),.language=tsc(U"Urdu"),.territory=tsc(U"India"),.revision=tsc(U"1.0"),.date=tsc(U"2009,June,09")},.monetary={.int_curr_symbol=tsc(U"INR "),.currency_symbol=tsc(U"₹"),.mon_decimal_point=tsc(U"."),.mon_thousands_sep=tsc(U","),.mon_grouping={monetary_mon_grouping_storage,2},.positive_sign=tsc(U""),.negative_sign=tsc(U"-"),.int_frac_digits=2,.frac_digits=2,.p_cs_precedes=1,.p_sep_by_space=0,.n_cs_precedes=1,.n_sep_by_space=0,.p_sign_posn=1,.n_sign_posn=1},.numeric={.decimal_point=tsc(U"."),.thousands_sep=tsc(U","),.grouping={numeric_grouping_storage,1}},.time={.abday={tsc(U"اتوار"),tsc(U"پیر"),tsc(U"منگل"),tsc(U"بدھ"),tsc(U"جمعرات"),tsc(U"جمعہ"),tsc(U"سنیچر")},.day={tsc(U"اتوار"),tsc(U"پیر"),tsc(U"منگل"),tsc(U"بدھ"),tsc(U"جمعرات"),tsc(U"جمعہ"),tsc(U"سنیچر")},.abmon={tsc(U"جنوری"),tsc(U"فروری"),tsc(U"مارچ"),tsc(U"اپریل"),tsc(U"مئی"),tsc(U"جون"),tsc(U"جولائی"),tsc(U"اگست"),tsc(U"ستمبر"),tsc(U"اکتوبر"),tsc(U"نومبر"),tsc(U"دسمبر")},.mon={tsc(U"جنوری"),tsc(U"فروری"),tsc(U"مارچ"),tsc(U"اپریل"),tsc(U"مئی"),tsc(U"جون"),tsc(U"جولائی"),tsc(U"اگست"),tsc(U"ستمبر"),tsc(U"اکتوبر"),tsc(U"نومبر"),tsc(U"دسمبر")},.d_t_fmt=tsc(U"%A %d %b %Y %I:%M:%S %p"),.d_fmt=tsc(U"%-d//%-m//%y"),.t_fmt=tsc(U"%I:%M:%S %p %Z"),.t_fmt_ampm=tsc(U"%I:%M:%S %p %Z"),.date_fmt=tsc(U"%A %d %b %Y %I:%M:%S %p %Z"),.am_pm={tsc(U"AM"),tsc(U"PM")},.week={7,19971130,1}},.messages={.yesexpr=tsc(U"^[+1yYہ]"),.noexpr=tsc(U"^[-0nNن]"),.yesstr=tsc(U"ہاں"),.nostr=tsc(U"نہیں")},.paper={.width=210,.height=297},.telephone={.tel_int_fmt=tsc(U"+%c ;%a ;%l"),.int_select=tsc(U"00"),.int_prefix=tsc(U"91")},.name={.name_fmt=tsc(U"%p%t%f%t%g"),.name_gen=tsc(U""),.name_miss=tsc(U"ڪماري"),.name_mr=tsc(U"جناب"),.name_mrs=tsc(U"محترمہ"),.name_ms=tsc(U"ڪمار")},.address={.postal_fmt=tsc(U"%z%c%T%s%b%e%r"),.country_name=tsc(U"بھارت"),.country_ab2=tsc(U"IN"),.country_ab3=tsc(U"IND"),.country_num=356,.country_car=tsc(U"IND"),.lang_name=tsc(U"اردو"),.lang_ab=tsc(U"ur"),.lang_term=tsc(U"urd"),.lang_lib=tsc(U"urd")},.measurement={.measurement=1}};


}
}

#include"../main.h"